package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json

import de.fraunhofer.iem.dataprovider.tool.entity.RuleEntity
import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable

@Serializable
data class SarifRuleJson(
    @SerialName("helpUri")
    val helpUri: String? = null,
    @SerialName("id")
    val id: String,
    @SerialName("name")
    val name: String,
    @SerialName("shortDescription")
    val shortDescription: SarifShortDescriptionJson
)

fun SarifRuleJson.asDbObject(): RuleEntity {
    val ruleEntity = RuleEntity()
    ruleEntity.toolRuleId = this.id
    ruleEntity.shortDescription = this.shortDescription.text
    return ruleEntity
}
