package de.fraunhofer.iem.dataprovider.tool.entity

import jakarta.persistence.*
import org.hibernate.Hibernate
import org.hibernate.annotations.CurrentTimestamp
import org.hibernate.annotations.UpdateTimestamp
import org.hibernate.generator.EventType
import java.time.Instant
import java.util.*

@Entity
@Table(name = "tool")
class ToolEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @Column(name = "name", length = 500)
    var name: String? = null

    @Column(name = "version")
    var version: String? = null

    @CurrentTimestamp(event = [EventType.INSERT])
    var createdAt: Instant? = null

    @UpdateTimestamp
    var lastUpdatedAt: Instant? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as ToolEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}