package de.fraunhofer.iem.dataprovider.tool.service

import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json.SarifToolJson
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.sarif.json.asDbObject
import de.fraunhofer.iem.dataprovider.tool.dto.CreateToolDto
import de.fraunhofer.iem.dataprovider.tool.entity.ToolEntity
import de.fraunhofer.iem.dataprovider.tool.repository.ToolRepository
import org.springframework.stereotype.Service

@Service
class ToolService(
    private val toolRepository: ToolRepository,
) {
    fun findOrCreateTool(tool: SarifToolJson): ToolEntity {
        val name = tool.driver.name
        val version = tool.driver.version

        return toolRepository.findByNameIgnoreCaseAndVersionIgnoreCase(name, version)
            ?: toolRepository.save(tool.asDbObject())
    }

    fun save(tool: ToolEntity) {
        toolRepository.save(tool)
    }

    fun findOrCreateTool(tool: CreateToolDto): ToolEntity {
        return toolRepository.findByNameIgnoreCaseAndVersionIgnoreCase(
            tool.name,
            tool.version
        )
            ?: toolRepository.save(tool.asDbObject())
    }
}