package de.fraunhofer.iem.dataprovider.ort

import de.fraunhofer.iem.dataprovider.dependency.dto.DependencyCreateDto
import de.fraunhofer.iem.dataprovider.dependency.dto.VulnerabilityCreateDto
import de.fraunhofer.iem.dataprovider.dependency.dto.VulnerabilityScoreCreateDto
import de.fraunhofer.iem.dataprovider.dependency.enumeration.VulnerabilityScoringSystemEnum
import kotlinx.coroutines.ExperimentalCoroutinesApi
import kotlinx.coroutines.test.runTest
import org.junit.jupiter.api.Test


class ParseOrtAdvisorResult {

    @Test
    fun parseOrt() {
//        val res =
//            getOrtResultsFromFile(Paths.get("src/test/kotlin/de/fraunhofer/iem/dataprovider/ort/ort-advisor-example-results.json"))
//        val advisorResult = res.advisorResults
//        assert(advisorResult[0].identifier == "first" && advisorResult[1].identifier == "second")
//        assert(advisorResult[0].vulnerabilities[0].id == "CVE-2021-45105")
//        assert(advisorResult[0].vulnerabilities[0].references[0].severity == "6.6")
//
//        val packages = res.packages
//        assert(packages[0].nameAndVersion == "Maven:ch.qos.logback:logback-classic:1.4.7")
    }

    @OptIn(ExperimentalCoroutinesApi::class)
    @Test
    fun parseOrtTask() = runTest {
//
//        suspend fun responseChannelDummy(event: Event): Unit {
//        }
//
//        val depService = mockk<DependencyService>()
//        val toolService = mockk<ToolService>()
//
//        val path = Paths.get("src/test/kotlin/de/fraunhofer/iem/dataprovider/ort/ort-advisor-example-results.json")
//        val ortAdvisorTask = OrtAdvisorTask(
//            repositoryDirectoryPath = "",
//            outputDirectoryPath = "",
//            responseChannel = ::responseChannelDummy,
//            repoId = UUID.randomUUID(),
//            dependencyService = depService,
////            toolService = toolService
//        )
//        val res = ortAdvisorTask.parseProcessResults(path.toAbsolutePath())
//        assert(res.size == 4)
//        assert(res[0].name == "Maven:ch.qos.logback:logback-classic:1.4.7")
//        assert(res[1].name == "Maven:ch.qos.logback:logback-core:1.4.7")
//        assert(res[2].name == "first" && res[2].vulnerabilities.size == 2)
//        assert(res[2].vulnerabilities[0].cveIdentifier == "CVE-2021-45105" && res[2].vulnerabilities[0].vulnerabilityScores[0].severity == "6.6")
//        assert(res[2].vulnerabilities[0].vulnerabilityScores[1].severity == "MEDIUM" && res[2].vulnerabilities[0].vulnerabilityScores[1].scoringSystem == VulnerabilityScoringSystemEnum.CVSSV3_1)
//        assert(res[2].vulnerabilities[0].vulnerabilityScores[0].scoringSystem == VulnerabilityScoringSystemEnum.CVSSV3)
    }

    @OptIn(ExperimentalCoroutinesApi::class)
    @Test
    fun ortToDbObject() = runTest {

        val vulnerabilityScores1 = mutableListOf<VulnerabilityScoreCreateDto>()
        vulnerabilityScores1.add(VulnerabilityScoreCreateDto("1.0", VulnerabilityScoringSystemEnum.CVSSV3))
        vulnerabilityScores1.add(VulnerabilityScoreCreateDto("2.0", VulnerabilityScoringSystemEnum.CVSSV3))

        val vulnerabilityScores2 = mutableListOf<VulnerabilityScoreCreateDto>()
        vulnerabilityScores2.add(VulnerabilityScoreCreateDto("3.0", VulnerabilityScoringSystemEnum.CVSSV3))
        vulnerabilityScores2.add(VulnerabilityScoreCreateDto("4.0", VulnerabilityScoringSystemEnum.CVSSV3))


        val vulnerabilities = mutableListOf<VulnerabilityCreateDto>()
        vulnerabilities.add(VulnerabilityCreateDto("MyCVETestIdent1", vulnerabilityScores1))
        vulnerabilities.add(VulnerabilityCreateDto("MyCVETestIdent2", vulnerabilityScores2))

        val createDependencyDependencyCreateDto = DependencyCreateDto(name = "TestDependency", vulnerabilities)

        val dbObject = createDependencyDependencyCreateDto.toDbObject()
        assert(dbObject.name == "TestDependency")
        assert(dbObject.vulnerabilities.size == 2)
        assert(dbObject.vulnerabilities.first().cveIdentifier == "MyCVETestIdent1")
    }
}